Loading...
Searching...
No Matches
pappso::PsmFeatures Class Reference

`#include <psmfeatures.h>`

## Public Member Functions

| PsmFeatures (PrecisionPtr ms2precision, double minimumMz)
| compute psm features
| ~PsmFeatures ()
void | setPeptideSpectrumCharge (const pappso::PeptideSp peptideSp, const MassSpectrum *p_spectrum, unsigned int parent_charge, unsigned int max_isotope_number)
double | getIntensityOfMatchedIon (Enums::PeptideIon ion_type)
| get the sum of intensity of a specific ion
double | getTotalIntensity () const
| sum of all peak intensities (matched or not)
double | getTotalIntensityOfMatchedIons () const
| sum of matched peak intensities
std::size_t | getNumberOfMatchedIons () const
| number of matched ions (peaks)
std::size_t | countMatchedIonComplementPairs () const
| count the number of matched ion complement
double | getTotalIntensityOfMatchedIonComplementPairs () const
| intensity of matched ion complement
const std::vector< std::pair< pappso::PeakIonIsotopeMatch, pappso::PeakIonIsotopeMatch > > & | getPeakIonPairs () const
double | getMatchedMzDiffMean () const
| get mean deviation of matched peak mass delta
double | getMatchedMzDiffSd () const
| get standard deviation of matched peak mass delta
double | getMaxIntensityMatchedIonComplementPairPrecursorMassDelta () const
| get the precursor mass delta of the maximum intensity pair of complement ions
std::size_t | getMaxConsecutiveIon (Enums::PeptideIon ion_type)
| get the maximum consecutive fragments of one ion type
std::size_t | getAaSequenceCoverage (Enums::PeptideIon ion_type)
| number of amino acid covered by matched ions
std::size_t | getComplementPairsAaSequenceCoverage ()
| number of amino acid covered by matched complement pairs of ions
double | getMaxIntensityPeakIonMatch (Enums::PeptideIon ion_type) const
double | getIonPairPrecursorMassDelta (const std::pair< pappso::PeakIonIsotopeMatch, pappso::PeakIonIsotopeMatch > &ion_pair) const
LinearRegression | getIonIsotopeLinearRegression () const

## Private Member Functions

void | findComplementIonPairs (const pappso::PeptideSp &peptideSp)

## Private Attributes

std::shared_ptr< FilterResampleKeepGreater > | msp_filterKeepGreater
std::shared_ptr< PeptideIsotopeSpectrumMatch > | msp_peptideSpectrumMatch
pappso::PeptideSp | msp_peptide
PrecisionPtr | m_ms2precision
std::list< Enums::PeptideIon > | m_ionList
double | m_spectrumSumIntensity
double | m_precursorTheoreticalMz
double | m_precursorTheoreticalMass
unsigned int | m_parentCharge = 1
std::vector< std::pair< pappso::PeakIonIsotopeMatch, pappso::PeakIonIsotopeMatch > > | m_peakIonPairs
double | m_matchedMzDiffMean = 0
double | m_matchedMzDiffMedian = 0
double | m_matchedMzDiffSd = 0

## Detailed Description

Todo
  write docs

Definition at line 45 of file psmfeatures.h.

## Constructor & Destructor Documentation

## PsmFeatures()

PsmFeatures::PsmFeatures | ( | PrecisionPtr | ms2precision,
|  | double | minimumMz )

compute psm features

Parameters

  ms2precision | precision of mass measurements for MS2 fragments
  minimumMz | ignore mz values under this threshold

Definition at line 35 of file psmfeatures.cpp.

{
m_ms2precision = ms2precision;
m_ionList.push_back(Enums::PeptideIon::y);
m_ionList.push_back(Enums::PeptideIon::b);
msp_filterKeepGreater = std::make_shared<FilterResampleKeepGreater>(minimumMz);
// msp_filterChargeDeconvolution =
// std::make_shared<FilterChargeDeconvolution>(m_ms2precision);
// msp_filterMzExclusion = std::make_shared<FilterMzExclusion>(
// PrecisionFactory::getPrecisionPtrFractionInstance(m_ms2precision, 0.5));
}
pappso::PsmFeatures::msp_filterKeepGreater
std::shared_ptr< FilterResampleKeepGreater > msp_filterKeepGreater
Definition psmfeatures.h:143
pappso::PsmFeatures::m_ionList
std::list< Enums::PeptideIon > m_ionList
Definition psmfeatures.h:149
pappso::PsmFeatures::m_ms2precision
PrecisionPtr m_ms2precision
Definition psmfeatures.h:148
pappso::Enums::PeptideIon::y
@ y
Cter amino ions.
Definition types.h:295
pappso::Enums::PeptideIon::b
@ b
Nter acylium ions.
Definition types.h:287

References pappso::Enums::b, m_ionList, m_ms2precision, msp_filterKeepGreater, and pappso::Enums::y.

## ~PsmFeatures()

PsmFeatures::~PsmFeatures | ( |  | ) |

Destructor

Definition at line 52 of file psmfeatures.cpp.

{
}

## Member Function Documentation

## countMatchedIonComplementPairs()

std::size_t pappso::PsmFeatures::countMatchedIonComplementPairs | ( |  | ) | const

count the number of matched ion complement

matched ion complement are ions with a sum compatible to the precursor mass

Definition at line 158 of file psmfeatures.cpp.

{
return m_peakIonPairs.size();
}
pappso::PsmFeatures::m_peakIonPairs
std::vector< std::pair< pappso::PeakIonIsotopeMatch, pappso::PeakIonIsotopeMatch > > m_peakIonPairs
Definition psmfeatures.h:157

References m_peakIonPairs.

## findComplementIonPairs()

void pappso::PsmFeatures::findComplementIonPairs | ( | const pappso::PeptideSp & | peptideSp | ) |

private

Definition at line 343 of file psmfeatures.cpp.

{
std::size_t peptide_size = peptideSp.get()->size();
std::vector<PeakIonIsotopeMatch> ion_isotope_list(
msp_peptideSpectrumMatch.get()->getPeakIonIsotopeMatchList().begin(),
msp_peptideSpectrumMatch.get()->getPeakIonIsotopeMatchList().end());
for(const pappso::PeakIonIsotopeMatch &peak_ion_ext : ion_isotope_list)
{
if(peptideIonIsNter(peak_ion_ext.getPeptideIonType()))
{
auto it = findComplementIonType(
ion_isotope_list.begin(), ion_isotope_list.end(), peak_ion_ext, peptide_size);
if(it != ion_isotope_list.end())
{ // contains the complementary ion
m_peakIonPairs.push_back({peak_ion_ext, *it});
}
}
}
}
pappso::Peptide::size
unsigned int size() const override
Definition peptide.cpp:217
pappso::PsmFeatures::msp_peptideSpectrumMatch
std::shared_ptr< PeptideIsotopeSpectrumMatch > msp_peptideSpectrumMatch
Definition psmfeatures.h:145
pappso::peptideIonIsNter
bool peptideIonIsNter(Enums::PeptideIon ion_type)
tells if an ion is Nter
Definition peptide.cpp:87
pappso::findComplementIonType
std::vector< PeakIonIsotopeMatch >::iterator findComplementIonType(std::vector< PeakIonIsotopeMatch >::iterator begin, std::vector< PeakIonIsotopeMatch >::iterator end, const PeakIonIsotopeMatch &peak_ion, std::size_t peptide_size)
find the first element containing the complementary ion complementary ion of y1 is b(n-1) for instanc...
Definition peakionisotopematch.cpp:30

References pappso::findComplementIonType(), m_peakIonPairs, msp_peptideSpectrumMatch, pappso::peptideIonIsNter(), and pappso::Peptide::size().

Referenced by setPeptideSpectrumCharge().

## getAaSequenceCoverage()

std::size_t pappso::PsmFeatures::getAaSequenceCoverage | ( | Enums::PeptideIon | ion_type | ) |

number of amino acid covered by matched ions

Definition at line 254 of file psmfeatures.cpp.

{
std::vector<bool> covered;
covered.resize(msp_peptide.get()->size(), false);
for(auto &peak : msp_peptideSpectrumMatch.get()->getPeakIonIsotopeMatchList())
{
if(peak.getPeptideNaturalIsotopeAverageSp().get()->getIsotopeNumber() == 0)
{ // only count with monotisotopic
if(peak.getPeptideIonType() == ion_type)
{
covered[peak.getPeptideFragmentIonSp().get()->size() - 1] = true;
}
}
}
return std::count(covered.begin(), covered.end(), true);
}
pappso::PsmFeatures::msp_peptide
pappso::PeptideSp msp_peptide
Definition psmfeatures.h:146

References msp_peptide, and msp_peptideSpectrumMatch.

## getComplementPairsAaSequenceCoverage()

std::size_t pappso::PsmFeatures::getComplementPairsAaSequenceCoverage | ( |  | ) |

number of amino acid covered by matched complement pairs of ions

Definition at line 273 of file psmfeatures.cpp.

{
std::vector<bool> covered;
covered.resize(msp_peptide.get()->size(), false);
for(auto &peak_pair : m_peakIonPairs)
{
std::size_t pos = peak_pair.first.getPeptideFragmentIonSp().get()->size() - 1;
covered[pos] = true;
covered[pos + 1] = true;
}
return std::count(covered.begin(), covered.end(), true);
}

References m_peakIonPairs, and msp_peptide.

## getIntensityOfMatchedIon()

double PsmFeatures::getIntensityOfMatchedIon | ( | Enums::PeptideIon | ion_type | ) |

get the sum of intensity of a specific ion

Parameters

  ion_type | ion species (y, b, ...)

Definition at line 128 of file psmfeatures.cpp.

{
double sum = 0;
for(const PeakIonMatch &peak_ion_match : *msp_peptideSpectrumMatch.get())
{
if(peak_ion_match.getPeptideIonType() == ion_type)
{
sum += peak_ion_match.getPeak().y;
}
}
return sum;
}
pappso::Enums::XicExtractMethod::sum
@ sum
sum of intensities
Definition types.h:279

References msp_peptideSpectrumMatch.

## getIonIsotopeLinearRegression()

LinearRegression pappso::PsmFeatures::getIonIsotopeLinearRegression | ( |  | ) | const

experimental use with caution

Definition at line 365 of file psmfeatures.cpp.

{
std::size_t peptide_size = msp_peptide.get()->size();
std::vector<PeakIonIsotopeMatch> ion_isotope_list(
msp_peptideSpectrumMatch.get()->getPeakIonIsotopeMatchList().begin(),
msp_peptideSpectrumMatch.get()->getPeakIonIsotopeMatchList().end());
Trace scaterplot;
for(Enums::PeptideIon ion_type : m_ionList)
{
std::vector<double> mono_th_intensities(peptide_size, 0);
std::vector<double> isotope_th_intensities(peptide_size, 0);
std::vector<double> mono_exp_intensities(peptide_size, 0);
std::vector<double> isotope_exp_intensities(peptide_size, 0);
for(const PeakIonIsotopeMatch &peak_ion_match : ion_isotope_list)
{
if(peak_ion_match.getPeptideIonType() == ion_type)
{
std::size_t vector_position =
peak_ion_match.getPeptideFragmentIonSp().get()->size() - 1;
PeptideNaturalIsotopeAverageSp iso_average_sp =
peak_ion_match.getPeptideNaturalIsotopeAverageSp();
if(iso_average_sp.get()->getIsotopeNumber() == 0)
{
mono_th_intensities[vector_position] = iso_average_sp.get()->getIntensityRatio();
mono_exp_intensities[vector_position] = peak_ion_match.getPeak().y;
}
else if(iso_average_sp.get()->getIsotopeNumber() == 1)
{
isotope_th_intensities[vector_position] =
iso_average_sp.get()->getIntensityRatio();
isotope_exp_intensities[vector_position] = peak_ion_match.getPeak().y;
}
}
}
for(std::size_t i = 0; i < mono_th_intensities.size(); i++)
{
if((mono_th_intensities[i] != 0) && (isotope_th_intensities[i] != 0))
{
DataPoint xy(mono_th_intensities[i] / isotope_th_intensities[i],
mono_exp_intensities[i] / isotope_exp_intensities[i]);
scaterplot.push_back(xy);
}
}
}
scaterplot.sortX();
LinearRegression linear_regression(scaterplot);
return linear_regression;
}
pappso::PeptideNaturalIsotopeAverage::getIntensityRatio
pappso_double getIntensityRatio() const
Definition peptidenaturalisotopeaverage.cpp:198
pappso::PeptideNaturalIsotopeAverage::getIsotopeNumber
unsigned int getIsotopeNumber() const
Definition peptidenaturalisotopeaverage.cpp:210
pappso::Trace::sortX
void sortX(Enums::SortOrder sort_order=Enums::SortOrder::ascending)
Definition trace.cpp:1071
pappso::Enums::MsDataFormat::xy
@ xy
(x,y) format
Definition types.h:154
pappso::Enums::PeptideIon
PeptideIon
Enums::PeptideIon enum defines all types of ions (Nter or Cter).
Definition types.h:286
pappso::PeptideNaturalIsotopeAverageSp
std::shared_ptr< const PeptideNaturalIsotopeAverage > PeptideNaturalIsotopeAverageSp
Definition peptidenaturalisotopeaverage.h:40

References pappso::PeptideNaturalIsotopeAverage::getIntensityRatio(), pappso::PeptideNaturalIsotopeAverage::getIsotopeNumber(), m_ionList, msp_peptide, msp_peptideSpectrumMatch, and pappso::Trace::sortX().

## getIonPairPrecursorMassDelta()

double pappso::PsmFeatures::getIonPairPrecursorMassDelta | ( | const std::pair< pappso::PeakIonIsotopeMatch, pappso::PeakIonIsotopeMatch > & | ion_pair | ) | const

Definition at line 327 of file psmfeatures.cpp.

{
qDebug() << m_precursorTheoreticalMz << " " << ion_pair.first.getPeak().x << " "
<< ion_pair.second.getPeak().x << " " << ion_pair.second.getCharge() << " "
<< ion_pair.first.getCharge() << " " << m_parentCharge;
double diff = (m_precursorTheoreticalMass + (MHPLUS * ion_pair.first.getCharge())) /
ion_pair.first.getCharge();
return (diff - (ion_pair.first.getPeak().x + ion_pair.second.getPeak().x -
((MHPLUS * ion_pair.first.getCharge())) / ion_pair.first.getCharge()));
}
pappso::PsmFeatures::m_precursorTheoreticalMz
double m_precursorTheoreticalMz
Definition psmfeatures.h:153
pappso::PsmFeatures::m_parentCharge
unsigned int m_parentCharge
Definition psmfeatures.h:155
pappso::PsmFeatures::m_precursorTheoreticalMass
double m_precursorTheoreticalMass
Definition psmfeatures.h:154
pappso::MHPLUS
const pappso_double MHPLUS(1.007276466879)

References m_parentCharge, m_precursorTheoreticalMass, m_precursorTheoreticalMz, and pappso::MHPLUS().

Referenced by getMaxIntensityMatchedIonComplementPairPrecursorMassDelta().

## getMatchedMzDiffMean()

double pappso::PsmFeatures::getMatchedMzDiffMean | ( |  | ) | const

get mean deviation of matched peak mass delta

Definition at line 189 of file psmfeatures.cpp.

{
return m_matchedMzDiffMean;
}
pappso::PsmFeatures::m_matchedMzDiffMean
double m_matchedMzDiffMean
Definition psmfeatures.h:159

References m_matchedMzDiffMean.

## getMatchedMzDiffSd()

double pappso::PsmFeatures::getMatchedMzDiffSd | ( |  | ) | const

get standard deviation of matched peak mass delta

Definition at line 183 of file psmfeatures.cpp.

{
return m_matchedMzDiffSd;
}
pappso::PsmFeatures::m_matchedMzDiffSd
double m_matchedMzDiffSd
Definition psmfeatures.h:161

References m_matchedMzDiffSd.

## getMaxConsecutiveIon()

std::size_t pappso::PsmFeatures::getMaxConsecutiveIon | ( | Enums::PeptideIon | ion_type | ) |

get the maximum consecutive fragments of one ion type

Parameters

  ion_type | ion species (y, b, ...)

Definition at line 202 of file psmfeatures.cpp.

{
std::size_t max = 0;
auto peak_ion_match_list = msp_peptideSpectrumMatch.get()->getPeakIonIsotopeMatchList();
peak_ion_match_list.erase(
std::remove_if(peak_ion_match_list.begin(),
peak_ion_match_list.end(),
[ion_type](const PeakIonIsotopeMatch &a) {
if(a.getPeptideIonType() != ion_type)
return true;
if(a.getPeptideNaturalIsotopeAverageSp().get()->getIsotopeNumber() > 0)
return true;
return false;
}),
peak_ion_match_list.end());
peak_ion_match_list.sort([](const PeakIonIsotopeMatch &a, const PeakIonIsotopeMatch &b) {
if(a.getCharge() < b.getCharge())
return true;
if(a.getPeptideIonType() < b.getPeptideIonType())
return true;
if(a.getPeptideFragmentIonSp().get()->size() < b.getPeptideFragmentIonSp().get()->size())
return true;
return false;
});
unsigned int charge = 0;
std::size_t size = 0;
std::size_t count = 0;
for(std::list<PeakIonIsotopeMatch>::iterator it = peak_ion_match_list.begin();
it != peak_ion_match_list.end();
it++)
{
qDebug() << it->toString() << max << " " << it->getPeak().x << " "
<< it->getPeptideNaturalIsotopeAverageSp().get()->getIsotopeNumber();
count++;
if((charge != it->getCharge()) || (size != (it->getPeptideFragmentIonSp().get()->size() - 1)))
{
count = 1;
charge = it->getCharge();
}
if(max < count)
max = count;
size = it->getPeptideFragmentIonSp().get()->size();
}
return max;
}
pappso::Enums::XicExtractMethod::max
@ max
maximum of intensities
Definition types.h:280
pappso::PeptideIonNter::a
@ a
Definition peptide.h:77
pappso::PeptideIonNter::b
@ b
Definition peptide.h:74

References pappso::a, pappso::b, and msp_peptideSpectrumMatch.

## getMaxIntensityMatchedIonComplementPairPrecursorMassDelta()

double pappso::PsmFeatures::getMaxIntensityMatchedIonComplementPairPrecursorMassDelta | ( |  | ) | const

get the precursor mass delta of the maximum intensity pair of complement ions

Definition at line 309 of file psmfeatures.cpp.

{
auto peak_it = std::max_element(
m_peakIonPairs.begin(),
m_peakIonPairs.end(),
[](const std::pair<pappso::PeakIonIsotopeMatch, pappso::PeakIonIsotopeMatch> &a,
const std::pair<pappso::PeakIonIsotopeMatch, pappso::PeakIonIsotopeMatch> &b) {
return ((a.first.getPeak().y + a.second.getPeak().y) <
(b.first.getPeak().y + b.second.getPeak().y));
});
if(peak_it == m_peakIonPairs.end())
return 0;
return getIonPairPrecursorMassDelta(*peak_it);
}
pappso::PsmFeatures::getIonPairPrecursorMassDelta
double getIonPairPrecursorMassDelta(const std::pair< pappso::PeakIonIsotopeMatch, pappso::PeakIonIsotopeMatch > &ion_pair) const
Definition psmfeatures.cpp:327

References pappso::a, pappso::b, getIonPairPrecursorMassDelta(), and m_peakIonPairs.

## getMaxIntensityPeakIonMatch()

double pappso::PsmFeatures::getMaxIntensityPeakIonMatch | ( | Enums::PeptideIon | ion_type | ) | const

Definition at line 290 of file psmfeatures.cpp.

{
std::list<pappso::PeakIonIsotopeMatch> peak_ion_type =
msp_peptideSpectrumMatch.get()->getPeakIonIsotopeMatchList();
peak_ion_type.remove_if(
[ion_type](const PeakIonIsotopeMatch &a) { return (a.getPeptideIonType() != ion_type); });
auto peak_it = std::max_element(peak_ion_type.begin(),
peak_ion_type.end(),
[](const PeakIonIsotopeMatch &a, const PeakIonIsotopeMatch &b) {
return (a.getPeak().y < b.getPeak().y);
});
if(peak_it == peak_ion_type.end())
return 0;
return peak_it->getPeak().y;
}

References pappso::a, pappso::b, and msp_peptideSpectrumMatch.

## getNumberOfMatchedIons()

std::size_t pappso::PsmFeatures::getNumberOfMatchedIons | ( |  | ) | const

number of matched ions (peaks)

Definition at line 196 of file psmfeatures.cpp.

{
return msp_peptideSpectrumMatch.get()->getPeakIonIsotopeMatchList().size();
}

References msp_peptideSpectrumMatch.

## getPeakIonPairs()

const std::vector< std::pair< pappso::PeakIonIsotopeMatch, pappso::PeakIonIsotopeMatch > > & pappso::PsmFeatures::getPeakIonPairs | ( |  | ) | const

Definition at line 164 of file psmfeatures.cpp.

{
return m_peakIonPairs;
}

References m_peakIonPairs.

## getTotalIntensity()

double PsmFeatures::getTotalIntensity | ( |  | ) | const

sum of all peak intensities (matched or not)

Definition at line 152 of file psmfeatures.cpp.

{
return m_spectrumSumIntensity;
}
pappso::PsmFeatures::m_spectrumSumIntensity
double m_spectrumSumIntensity
Definition psmfeatures.h:151

References m_spectrumSumIntensity.

## getTotalIntensityOfMatchedIonComplementPairs()

double pappso::PsmFeatures::getTotalIntensityOfMatchedIonComplementPairs | ( |  | ) | const

intensity of matched ion complement

Definition at line 170 of file psmfeatures.cpp.

{
double sum = 0;
for(auto &peak_pairs : m_peakIonPairs)
{
sum += peak_pairs.first.getPeak().y;
sum += peak_pairs.second.getPeak().y;
}
return sum;
}

References m_peakIonPairs.

## getTotalIntensityOfMatchedIons()

double PsmFeatures::getTotalIntensityOfMatchedIons | ( |  | ) | const

sum of matched peak intensities

Definition at line 141 of file psmfeatures.cpp.

{
double sum = 0;
for(const PeakIonMatch &peak_ion_match : *msp_peptideSpectrumMatch.get())
{
sum += peak_ion_match.getPeak().y;
}
return sum;
}

References msp_peptideSpectrumMatch.

## setPeptideSpectrumCharge()

void PsmFeatures::setPeptideSpectrumCharge | ( | const pappso::PeptideSp | peptideSp,
|  | const MassSpectrum * | p_spectrum,
|  | unsigned int | parent_charge,
|  | unsigned int | max_isotope_number )

Definition at line 57 of file psmfeatures.cpp.

{
m_peakIonPairs.clear();
msp_peptide = peptideSp;
MassSpectrum spectrum(*p_spectrum);
msp_filterKeepGreater.get()->filter(spectrum);
// msp_filterChargeDeconvolution.get()->filter(spectrum);
// msp_filterMzExclusion.get()->filter(spectrum);
msp_peptideSpectrumMatch = std::make_shared<PeptideIsotopeSpectrumMatch>(
spectrum, peptideSp, parent_charge, m_ms2precision, m_ionList, max_isotope_number, 1);
msp_peptideSpectrumMatch.get()->dropPeaksLackingMonoisotope();
m_spectrumSumIntensity = spectrum.sumY();
qDebug() << " accumulate";
std::vector<double> delta_list;
// TODO compute number of matched complementary peaks having m/z compatible
// with the precursor
m_precursorTheoreticalMz = peptideSp.get()->getMz(parent_charge);
m_precursorTheoreticalMass = peptideSp.get()->getMass();
m_parentCharge = parent_charge;
findComplementIonPairs(peptideSp);
for(const pappso::PeakIonIsotopeMatch &peak_ion :
msp_peptideSpectrumMatch.get()->getPeakIonIsotopeMatchList())
{
delta_list.push_back(peak_ion.getPeptideFragmentIonSp().get()->getMz(peak_ion.getCharge()) -
peak_ion.getPeak().x);
}
pappso::pappso_double sum = std::accumulate(delta_list.begin(), delta_list.end(), 0);
qDebug() << " delta_list.size()=" << delta_list.size();
m_matchedMzDiffMean = 0;
m_matchedMzDiffMedian = 0;
m_matchedMzDiffSd = 0;
if(delta_list.size() > 0)
{
m_matchedMzDiffMean = sum / ((pappso::pappso_double)delta_list.size());
std::sort(delta_list.begin(), delta_list.end());
m_matchedMzDiffMedian = delta_list[(delta_list.size() / 2)];
qDebug() << " sd";
m_matchedMzDiffSd = 0;
for(pappso::pappso_double val : delta_list)
{
// sd = sd + ((val - mean) * (val - mean));
m_matchedMzDiffSd += std::pow((val - m_matchedMzDiffMean), 2);
}
m_matchedMzDiffSd = m_matchedMzDiffSd / delta_list.size();
m_matchedMzDiffSd = std::sqrt(m_matchedMzDiffSd);
}
else
{
}
}
pappso::Ion::getMz
virtual pappso_double getMz(unsigned int charge) const final
Definition ion.cpp:45
pappso::Peptide::getMass
pappso_double getMass()
Definition peptide.cpp:375
pappso::PsmFeatures::findComplementIonPairs
void findComplementIonPairs(const pappso::PeptideSp &peptideSp)
Definition psmfeatures.cpp:343
pappso::PsmFeatures::m_matchedMzDiffMedian
double m_matchedMzDiffMedian
Definition psmfeatures.h:160
pappso::pappso_double
double pappso_double
A type definition for doubles.
Definition types.h:60

References findComplementIonPairs(), pappso::Peptide::getMass(), pappso::Ion::getMz(), m_ionList, m_matchedMzDiffMean, m_matchedMzDiffMedian, m_matchedMzDiffSd, m_ms2precision, m_parentCharge, m_peakIonPairs, m_precursorTheoreticalMass, m_precursorTheoreticalMz, m_spectrumSumIntensity, msp_filterKeepGreater, msp_peptide, msp_peptideSpectrumMatch, and pappso::Trace::sumY().

## Member Data Documentation

## m_ionList

std::list<Enums::PeptideIon> pappso::PsmFeatures::m_ionList

private

Definition at line 149 of file psmfeatures.h.

Referenced by PsmFeatures(), getIonIsotopeLinearRegression(), and setPeptideSpectrumCharge().

## m_matchedMzDiffMean

double pappso::PsmFeatures::m_matchedMzDiffMean = 0

private

Definition at line 159 of file psmfeatures.h.

Referenced by getMatchedMzDiffMean(), and setPeptideSpectrumCharge().

## m_matchedMzDiffMedian

double pappso::PsmFeatures::m_matchedMzDiffMedian = 0

private

Definition at line 160 of file psmfeatures.h.

Referenced by setPeptideSpectrumCharge().

## m_matchedMzDiffSd

double pappso::PsmFeatures::m_matchedMzDiffSd = 0

private

Definition at line 161 of file psmfeatures.h.

Referenced by getMatchedMzDiffSd(), and setPeptideSpectrumCharge().

## m_ms2precision

PrecisionPtr pappso::PsmFeatures::m_ms2precision

private

Definition at line 148 of file psmfeatures.h.

Referenced by PsmFeatures(), and setPeptideSpectrumCharge().

## m_parentCharge

unsigned int pappso::PsmFeatures::m_parentCharge = 1

private

Definition at line 155 of file psmfeatures.h.

Referenced by getIonPairPrecursorMassDelta(), and setPeptideSpectrumCharge().

## m_peakIonPairs

std::vector<std::pair<pappso::PeakIonIsotopeMatch, pappso::PeakIonIsotopeMatch> > pappso::PsmFeatures::m_peakIonPairs

private

Definition at line 157 of file psmfeatures.h.

Referenced by countMatchedIonComplementPairs(), findComplementIonPairs(), getComplementPairsAaSequenceCoverage(), getMaxIntensityMatchedIonComplementPairPrecursorMassDelta(), getPeakIonPairs(), getTotalIntensityOfMatchedIonComplementPairs(), and setPeptideSpectrumCharge().

## m_precursorTheoreticalMass

double pappso::PsmFeatures::m_precursorTheoreticalMass

private

Definition at line 154 of file psmfeatures.h.

Referenced by getIonPairPrecursorMassDelta(), and setPeptideSpectrumCharge().

## m_precursorTheoreticalMz

double pappso::PsmFeatures::m_precursorTheoreticalMz

private

Definition at line 153 of file psmfeatures.h.

Referenced by getIonPairPrecursorMassDelta(), and setPeptideSpectrumCharge().

## m_spectrumSumIntensity

double pappso::PsmFeatures::m_spectrumSumIntensity

private

Definition at line 151 of file psmfeatures.h.

Referenced by getTotalIntensity(), and setPeptideSpectrumCharge().

## msp_filterKeepGreater

std::shared_ptr<FilterResampleKeepGreater> pappso::PsmFeatures::msp_filterKeepGreater

private

Definition at line 143 of file psmfeatures.h.

Referenced by PsmFeatures(), and setPeptideSpectrumCharge().

## msp_peptide

pappso::PeptideSp pappso::PsmFeatures::msp_peptide

private

Definition at line 146 of file psmfeatures.h.

Referenced by getAaSequenceCoverage(), getComplementPairsAaSequenceCoverage(), getIonIsotopeLinearRegression(), and setPeptideSpectrumCharge().

## msp_peptideSpectrumMatch

std::shared_ptr<PeptideIsotopeSpectrumMatch> pappso::PsmFeatures::msp_peptideSpectrumMatch

private

Definition at line 145 of file psmfeatures.h.

Referenced by findComplementIonPairs(), getAaSequenceCoverage(), getIntensityOfMatchedIon(), getIonIsotopeLinearRegression(), getMaxConsecutiveIon(), getMaxIntensityPeakIonMatch(), getNumberOfMatchedIons(), getTotalIntensityOfMatchedIons(), and setPeptideSpectrumCharge().

The documentation for this class was generated from the following files:

- pappsomspp/core/psm/features/psmfeatures.h
- pappsomspp/core/psm/features/psmfeatures.cpp